<template>
  <el-drawer
    title="物料详情"
    :append-to-body="true"
    :model-value="modelValue"
    @update:model-value="$emit('update:modelValue', $event)"
    :show-close="false"
    direction="rtl"
    :size="computedSize"
    :before-close="handleClose"
  >
    <template v-if="nodeId">
      <div v-loading="loading" style="height: 100%">
        <el-table :data="materials" style="width: 100%">
          <el-table-column prop="name" label="物料名称" width="180" />
          <el-table-column prop="code" label="物料编码" width="180" />
          <el-table-column prop="model" label="规格型号" width="180" />
          <el-table-column prop="unit" label="单位" width="180" />
          <el-table-column
            label="创建时间"
            align="center"
            prop="createTime"
            width="180"
            :formatter="dateFormatter"
          />
          <el-table-column label="操作" align="right">
            <template #default="scope">
              <el-button
                size="small"
                type="danger"
                @click="emit('delete', scope.row)"
              >删除</el-button>
            </template>
          </el-table-column>
        </el-table>
        <!-- 分页 -->
        <Pagination
          :total="total"
          v-model:page="queryParams.pageNo"
          v-model:limit="queryParams.pageSize"
          @pagination="loadMaterials(props.nodeId)"
        />
      </div>
    </template>

  </el-drawer>
</template>
<script setup lang="ts">

import { ref, watch, defineOptions, defineEmits } from 'vue'
import { ElMessage } from 'element-plus'
import * as PmsMaterialApi from '@/api/pms/material'
import {dateFormatter} from "@/utils/formatTime";
const drawerVisible = ref<boolean>(false)
const emit = defineEmits(['update:modelValue', 'add', 'delete'])

defineOptions({
  name: 'MaterialListDrawer'
})

const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  createTime: [],
  bomId: '',
  name: '',
  code: ''
})

const windowWidth = ref(window.innerWidth)
// 动态计算百分比
const computedSize = computed(() => {
  return windowWidth.value > 1200 ? '60%' : '80%'
})

const loading = ref(false)
const total = ref(0) // 列表的总页数
const materials = ref([])

const props = defineProps({
  modelValue: Boolean,
  nodeId: Number
})

// 监听bom树节点ID变化
watch(() => props.nodeId, async (newVal) => {
  if (newVal) {
    await loadMaterials(newVal)
  }
})

// 加载指定bom节点下的物料数据
const loadMaterials = async (nodeId) => {
  queryParams.bomId = nodeId
  try {
    loading.value = true
    // API调用
    const data = await PmsMaterialApi.listByBomId(queryParams)
    materials.value = data.list
    total.value = data.total
  } catch (error) {
    ElMessage.error('数据加载失败')
  } finally {
    loading.value = false
  }
}

// 打开抽屉
const openDrawer = () => {
  drawerVisible.value = true
}

// 关闭抽屉
const closeDrawer = () => {
  drawerVisible.value = false
}

// 关闭抽屉
const handleClose = () => {
  emit('update:modelValue', false)
  materials.value = []
}

defineExpose({ openDrawer, closeDrawer }) // 暴露方法给父组件

</script>

<style lang="scss" scoped></style>
